% Einstein's riddle:
% There are 5 houses in 5 different colors in a row.
% In each house lives a person with a different nationality.
% These 5 owners drink a certain drink, smoke a certain brand of cigar,
% and keep a certain pet. No owners have the same pet,
% smoke the same brand of cigar or drink the same drink.

template([1/[Nationality1, Color1, Drink1, Cigar1, Pet1],
          2/[Nationality2, Color2, Drink2, Cigar2, Pet2],
          3/[Nationality3, Color3, Drink3, Cigar3, Pet3],
          4/[Nationality4, Color4, Drink4, Cigar4, Pet4],
          5/[Nationality5, Color5, Drink5, Cigar5, Pet5]]).

einstein(Houses) :-
    member(_/[brit, red, _, _, _], Houses),        % the Brit lives in the red house
    member(_/[swede, _, _, _, dogs], Houses),      % the Swede keeps dogs as pets
    member(_/[dane, _, tea, _, _], Houses),        % the Dane drinks tea
    member(G/[_, green, coffee, _, _], Houses),    % the green house owner drinks coffee
    member(W/[_, white, _, _, _], Houses),         
    G =:= W - 1,                                   % the green house is on the immediate left of the white house
    member(_/[_, _, _, pallMall, birds], Houses),  % the person who smokes Pall Mall rears birds
    member(D/[_, yellow, _, dunhill, _], Houses),  % the owner of the yellow house smokes Dunhill
    member(3/[_, _, milk, _, _], Houses),          % the man living in the house right in the center drinks milk
    member(1/[norwegian, _, _, _, _], Houses),     % the Norwegian lives in the first house
    member(B/[_, _, _, blends, _], Houses),
    member(C/[_, _, _, _, cats], Houses),
    abs(B - C) =:= 1,                              % the man who smokes blends lives next to the one who keeps cats
    member(H/[_, _, _, _, horses], Houses),
    abs(D - H) =:= 1,                              % the man who keeps horses lives next to the one who smokes Dunhill
    member(_/[_, _, beer, bluemaster, _], Houses), % the owner who smokes Bluemaster drinks beer
    member(_/[german, _, _, prince, _], Houses),   % the German smokes prince
    member(2/[_, blue, _, _, _], Houses),          % the Norwegian lives next to the blue house
    member(WT/[_, _, water, _, _], Houses),
    abs(B - WT) =:= 1.                             % the man who smokes blends has a neighbor who drinks water

solve(Houses) :- template(Houses), einstein(Houses).