(deftemplate edge (slot from) (slot to) (slot cost))
(deftemplate find (slot source) (slot dest))
(deftemplate path (multislot nodes) (slot cost))

(deffacts stuff
    (edge (from a) (to b) (cost 1))
    (edge (from a) (to e) (cost 9))
    (edge (from b) (to c) (cost 2))
    (edge (from b) (to d) (cost 1))
    (edge (from c) (to d) (cost 1))
    (edge (from c) (to e) (cost 4))
    (edge (from c) (to a) (cost 2))
    (edge (from d) (to e) (cost 2))
    (edge (from a) (to c) (cost 1))
    (find (source a) (dest e)))
    
(defrule init
    (find (source ?s))
  =>
    (assert (path (nodes ?s) (cost 0))))
    
(defrule expand
    (path (nodes $?prefix ?last) (cost ?pc))
    (edge (from ?last) (to ?neighbor) (cost ?ec))
    (test (and (neq ?neighbor ?last)
               (not (member ?neighbor $?prefix))))
  =>
    (assert (path (nodes $?prefix ?last ?neighbor)
                  (cost (+ ?pc ?ec)))))
    
(defrule prune
    (declare (salience 10))
    (path (nodes $? ?dest) (cost ?gc))
    ?f <- (path (nodes $? ?dest) (cost ?bc))
    (test (> ?bc ?gc))
  =>
    (retract ?f))
    
(defrule announce
    (declare (salience -10))
    (find (dest ?d))
    (path (nodes $?prefix ?d))
  =>
    (printout t $?prefix " " ?d crlf))