(deftemplate edge (slot from) (slot to) (slot cost))
(deftemplate find (slot source) (slot dest))

(deffacts stuff
	(edge (from a) (to b) (cost 1))
	(edge (from a) (to e) (cost 9))
	(edge (from b) (to c) (cost 2))
	(edge (from b) (to d) (cost 1))
	(edge (from c) (to d) (cost 1))
	(edge (from c) (to e) (cost 4))
	(edge (from c) (to a) (cost 2))
	(edge (from d) (to e) (cost 2))
	(edge (from a) (to c) (cost 1))
	(find (source a) (dest e)))

(defrule init
	(find (source ?s))
  =>
	(assert (path ?s))
	(set-strategy breadth))

(defrule expand
	(path $?prefix ?last)
	(edge (from ?last) (to ?neighbor))
	(test (and	(neq ?neighbor ?last)
				(not (member ?neighbor $?prefix))))
  =>
	(assert (path $?prefix ?last ?neighbor)))

(defrule announce
	(declare (salience 10))
	(find (dest ?d))
	(path $?prefix ?d)
  =>
	(printout t $?prefix ?d crlf) (halt))