#|
Funcție care transformă o funcție de un număr fix de parametri
într-o funcție ce acceptă oricâți parametri, la un moment dat.

Explicațiile următoare se referă la noua funcție.
* Cât timp parametrii sunt insuficienți, aceștia sunt acumulați, intern,
  iar valoarea este o nouă funcție, care așteaptă restul parametrilor.
* Când parametrii ating numărul exact, funcția inițială este aplicată
  asupra lor.
* Când numărul de parametri depășește numărul exact, este întors
  simbolul 'too-many.
* Parametrul special, 'how-many?, interoghează numărul de parametri furnizați
  până în acel moment.
|#
(define curried
  (λ (f)
    (if (not (procedure? f))
        'non-procedure
        (let ([max (procedure-arity f)])
          (if (not (number? max))
              'non-number
              (letrec ([self (λ (partial-args)
                               (λ current-args
                                 (let ([applicator (λ ()
                                                     (let ([sum (+ (length partial-args) (length current-args))])
                                                       (if (> sum max)
                                                           'too-many
                                                           (let ([args (append partial-args current-args)])
                                                             (if (= sum max)
                                                                 (apply f args)
                                                                 (self args))))))])
                                   (cond [(null? current-args) (applicator)]
                                         [(eq? (car current-args) 'how-many?) (length partial-args)]
                                         [else (applicator)]))))])
                (self '())))))))

(cons 1 2)
(curried 3)

(define curried-cons (curried cons))
curried-cons
(curried-cons 1 2)
((curried-cons 1) 2)

(define cons-1 (curried-cons 1))
cons-1
(cons-1)
(cons-1 2)
(cons-1 3 4)
(cons-1 'how-many?)