#|
Funcție care transformă o altă funcție într-o versiune care își monitorizează
numărul de aplicări. Este necesară o stare internă, reprezentată de o variabilă
locală, modificată, prin "set!", la fiecare aplicare.

Sunt acceptați umrmătorii parametri speciali:
* 'how-many?: numărul de aplicări realizate până la acel moment
* 'reset!: reinițializează numărul de aplicări la 0.
|#
(define monitor
  (λ (f)
      (let ([counter 0])
        (λ args
          (let ([applicator (λ ()
                              (set! counter (+ counter 1))
                              (apply f args))])
            (cond [(null? args) (applicator)]
                  [(eq? (car args) 'how-many?) counter]
                  [(eq? (car args) 'reset!) (set! counter 0)]
                  [else (applicator)]))))))

(define m-cons (monitor cons))
(m-cons 1 2)
(m-cons 3 4)
(m-cons 'how-many?)
(m-cons 'reset!)
(m-cons 'how-many?)