(include "search-breadth-lazy.rkt")

; board -> '((1 . 2) (2 . 4) (3 . 1) (4 . 3))

(define queens
  (lambda (n)
    (lazy-breadth-search-goal '()
                              (expandq n)
                              (lambda (board)
                                (= (length board) n)))))

(define lin car)
(define col cdr)

(define conflict?
  (lambda (q1 q2)
    (or (= (lin q1) (lin q2))
        (= (col q1) (col q2))
        (= (abs (- (lin q1) (lin q2)))
           (abs (- (col q1) (col q2)))))))

(define forall?
  (lambda (p? l)
    (foldl (lambda (x y) (and x y)) #t (map p? l))))

(define expandq
  (lambda (n)
    (lambda (board)
      (let ((line (+ (length board) 1))
            (columns (let func ((n n))
                       (if (zero? n) '()
                           (cons n (func (- n 1)))))))
        (if (> line n) '()
            (map (lambda (column)
                   (cons (cons line column) board))
                 (filter (lambda (column)
                           (forall? (lambda (queen)
                                      (not (conflict? queen (cons line column))))
                                    board))
                         columns)))))))

(stream-take 10 (queens 8))