(include "stream-operators.rkt")

(define lazy-breadth-search
  (lambda (init expand)
    (letrec
        ([search
          (lambda (states)
            (if (stream-null? states) states
                (let ([state (stream-car
                              states)]
                      [states (stream-cdr
                               states)])
                  (stream-cons
                   state
                   (search (stream-append
                            states
                            (expand
                             state)))))))])
      (search (stream-cons init stream-null)))))

(define lazy-breadth-search-goal
  (lambda (init expand goal?)
    (stream-filter
     goal?
     (lazy-breadth-search init expand))))