{-
Expresii aritmetice, simple, ce pot contine numere, operatorul +, si paranteze.

Exemplu:
(2+(3+5))
are forma intermediara
Add [Number 2, Add [Number 3, Number 5]]
-}

module Expr where

import Parser
import Data.Char (isDigit)

data Expr
    = Number Integer
    | Add [Expr]
    deriving Show

expr = (atom >*>
       (maxList $ (token '+' >*> atom) `transform` snd))
       `transform` f
  where
    f (e, []) = e
    f (e, l)  = Add $ e : l

atom = number `alt`
       ((token '(' >*> expr >*> token ')') `transform` f)
  where
    f (_, (e, _)) = e

number = (spotWhile1 isDigit) `transform` (\x -> Number (read x :: Integer))